<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="Content-type" content="text/html;charset=UTF-8" />
<title>Freghar's Gitlog - Dependencies</title>
</head>


<body>

<h1>Dependencies</h1>

<p>Let's say I changed file F (which is a blob object) in this hierarchy:</p>
<pre>
  T            - root tree
 / \
T   T -        - subtrees
|\  |\ \
B B T B B      - another subtree, some blobs (B)
    |\
    B F
</pre>
<p>This hierarchy is the way the Git internally works. When you make a classic commit, it depends upon his parent (previous commit) and a tree.<br />
Imagine we have some commit which depends on our root tree T shown in the ascii art. Now, imagine you make a commit on top of it, changing file F. The new commit will depend upon it's previous commit and a WHOLE NEW root tree object. However, the new root tree object will be really similar to our old one:</p>
<pre>
  U            - new root tree
 / \
T   U -        - subtrees
|\  |\ \
B B U B B      - another subtree, some blobs (B)
    |\
    B G
</pre>
<p>"U" stands for completely new tree object, "G" stands for new blob object.</p>

<p>So by making the commit, you actually created 1+3+1 objects (1 commit, 3 trees, 1 blob). It's because git can reuse blobs and trees from previous trees as dependencies - ALL objects are in some kind of object pool where anything can depend on anything else.<br />
And because a tree is nothing more than a list of "pointers" to another trees or blobs, we can actually make those pointers point to previously used trees / blobs if they weren't changed (blobs B and trees T in the second ascii art).</p>

<p>If it isn't still clear for you, here's a timeline for our two mentioned commits and their dependencies (C = commit):</p>
<pre>
... - C -- C
     /    /
    T    U
   / \  / \
  .. .... ..
</pre>
<p>Simple as that!</p>
<br />

<p>note: "root tree", "subtree" and "tree" are all classic tree objects, I just gave them unique names to show their position in hierarchy, but they are the same "data type"</p>

</body>


</html>
